#!/usr/bin/perl
#
#    AFBackup Config and Mantainance Module
#    Copyright (C) 1999 by Dirk Wallmeier
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    This module inherited from the Webmin Module Template 0.79.1 by tn

require './afbackup-lib.pl';
&ReadParse();

$run=$in{'run'};
$run_file = $config{'optionS'}.$run;

if ($in{'change'}) {

	$ref_lines = &read_file_lines($run_file);
	${$ref_lines}[0] = "server=$in{'server'}"; 		
	${$ref_lines}[1] = "serverport=$in{'serverport'}"; 		
	${$ref_lines}[2] = "mailto=$in{'mailto'}"; 		
	${$ref_lines}[3] = "debug=$in{'debug'}"; 		
	flush_file_lines();

	&redirect("backup_run.cgi?run=".$in{'run'});

} elsif ($in{'startnow'}) {

	exec ("./run_schedule.pl", "-r".$in{'run'}, "-S".$in{'cartset'} ) if ( $in{'run'} && $in{'cartset'});
	&redirect("backup_run.cgi?run=".$in{'run'});

} elsif ($in{'startlater'}) {

	
	&redirect("backup_run.cgi?run=".$in{'run'});

} elsif ($in{'add'}) {

	open (FILE, ">> ".$run_file)  or print "Error opening: $run_file<br>";
	# add=add&clhost=host&clconf=conf&cartset=7&full_incr=incr&level=0
	print (FILE $in{'clhost'}." ".$in{'clconf'}." ".$in{'full_incr'}." ".$in{'level'}."\n");
	close (FILE);
	
	&redirect("backup_run.cgi?run=".$in{'run'});

} elsif ($in{'edit'}) {
	&header("Backup Run", "", "");
	print "<hr>\n";
	print "<font size=+1>edit run</font>\n";
	print "<hr>\n";
	&footer("backup_run.cgi?run=".$in{'run'}, "Backup Runs");

} elsif ($in{'deljob'}) {
	
	$ref_lines = &read_file_lines($run_file);
	$remove = $in{'job'} + 5;
	splice(@$ref_lines, $remove, 1);
	flush_file_lines();
	
	&redirect("backup_run.cgi?run=".$in{'run'});
	#&header("Backup Run", "", "");
	#print "<hr>\n";
	#print "<font size=+1>delete jog nr:".$remove."</font>\n";
	##print "<br>@$ref_lines"."<br>\n";
	#print "<hr>\n";
	#&footer("backup_run.cgi?run=".$in{'run'}, "Backup Runs");

} elsif ($in{'delrun'}) {
	if ( exists $in{'del_file'} ) {
		my $d = $config{'optionS'}.$in{'del_file'}.".run";
		$cnt = unlink $d;
       	#&redirect("scheduler.cgi");
       	&header("Delete Run", "", "");
		print "<hr>\n";
		if ($cnt > 0) { print "<font size=+1>deleted run: $d</font>\n"; }
		else { print "<font size=+1>error deleting run: $d</font>\n"; }
		print "<hr>\n";
		&footer("scheduler.cgi", "Backup Runs");

	} else {
		&header("Delete Run", "", "");
		print "<hr>\n";
		print "<form action=backup_run.cgi>\n";
		print "<table border width=100%>\n";
		print "<tr $tb> <td><b>Delete one of Runs found in <i>$config{'optionS'}</i> :</b></td></tr>\n";
		print "<tr $cb> <td><table width=100%>\n";
		foreach $run (&get_run_list) {
	        print "<tr><td><input type=radio name=del_file value=$run>$run</td></tr> \n";
		}
		print "</table></td></tr></table><p>\n";
		print "<input type=submit name=delrun value=\"Delete\"> ", "<input type=reset value=\"Undo\">\n";
		print "</form>\n";
		&footer("scheduler.cgi", "Backup Runs");
	}
} elsif ($in{'newrun'}) {
	if ($in{'new_file'}) {
		$conf_dir = $config{'optionS'};
        	$newfile=$in{'new_file'};      
        	#system("/bin/touch", $conf_dir.$newfile);
        	open NEWFILE , "> ".$conf_dir.$newfile;
        	print NEWFILE "server=\n";
        	print NEWFILE "serverhost=\n";
        	print NEWFILE "mailto=\n";
        	print NEWFILE "debug=\n";
        	print NEWFILE "jobs";
        	close NEWFILE;
        	&redirect("backup_run.cgi?run=$newfile");
	} else {
		&header("Backup Run", "", "");
		print "<hr>\n";
		print "<form action=backup_run.cgi>\n";
		print "New Backup Run to create: ";
		print "<input type=hidden name=newrun value=1 >";
		print "<input name=new_file value=new.run >";
		print "<input type=submit value=\"Create\"> <input type=reset value=\"Undo\">\n";
		print "</form>\n";
		print "<hr>\n";
		&footer("backup_run.cgi?run=".$in{'run'}, "Backup Runs");
	}
	
} else {

&header("Backup Run", "", "");
print "<center><font size=+1>$run_file</font></center>\n";
print "<hr>\n";

print "<form action=backup_run.cgi>\n";
print "<input type=hidden name=run value=$run >";

open (FILE, $run_file)  or print "Error opening: $run_file<br>";

until ( $line =~ /jobs/ ) {
	$line = <FILE>;
	($key, $value) = split("=", $line);
	chomp($value);
	if 	($key eq "server") 	{ $server = $value }
	elsif	($key eq "serverport") 	{ $serverport = $value }  
	elsif	($key eq "mailto") 	{ $mailto = $value }  
	elsif	($key eq "debug") 	{ $debug = $value }
	
}
print "<table width=100% >\n";
print "<tr $tb><td colspan=4>Server Settings</td>\n";
print "<tr $cb>";
print "<td><b>Server :</b></td>";
print "<td><input name=server value=\"$server\"></td>\n";
print "<td><b>Port :</b></td>";
print "<td><input name=serverport value=\"$serverport\"></td></tr>\n";
print "<tr $cb>";
print "<td><b>Send Mail to :</b></td>";
print "<td><input name=mailto value=\"$mailto\"></td>\n";
print "<td><b>Debug Level :</b></td>";
print "<td><input name=debug value=\"$debug\"></td></tr>\n";
print "<tr $cb>";
print "<td colspan=4><input type=submit name=change value=Change></td></tr>\n";
print "</table>\n";

print "<table border width=100% >\n";
print "<tr $tb>\n";
print "<td><b>&nbsp;</b></td>";
print "<td><b>Client Host</b></td>";
print "<td><b>Client Conf File</b></td>";
print "<td><b>full/incr</b></td>";
print "<td><b>(incr Level)</b></td>";
print "</tr>\n";

$jobnr=0;
foreach $job (<FILE>) {
	($clhost, $clconf, $full_incr, $level) = split(' ', $job);
	print "<tr $cb>\n";
	print "<td><input type=radio name=job value=".$jobnr++."></td>";
	print "<td>$clhost</td>";
	print "<td>$clconf</td>";
	print "<td>$full_incr</td>";
	print "<td>$level</td>";
	print "</tr>\n";
}
close(FILE);

print "<tr $cb>\n";
print "<td><input type=submit name=add value=add></td>";
print "<td><input name=clhost size=20></td>";
print "<td><input name=clconf size=50></td>";
print "<td><input name=full_incr type=radio value=full>full <input name=full_incr type=radio value=incr>incr </td>";
print "<td><input name=level size=3></td>";
print "</tr>\n";

print "<tr $cb>";
print "<td colspan=5><input type=submit name=edit value=\"Edit selected Run\">";
print "<input type=submit name=deljob value=\"Delete selected job\">";
print "<input type=reset value=Undo>";
print "</td></tr>\n";
print "</table>\n";
print "</form>\n";

print "<form action=backup_run.cgi>\n";
print "<input type=hidden name=run value=$run >";
print "<table width=100%>";
print "<tr $tb>";
print "<td colspan=2>Start this backup run</br></td></tr>\n";
print "<tr $cb><td colspan=2 allign=center><input type=submit name=startnow value=\" NOW !\" width=100%></td></tr>\n";
print "<tr $cb><td allign=center><input type=submit name=startlater value=\" later \" width=100%></td>";
print "<td><input name=dd size=2>:<input name=hh size=2>:<input name=mm size=2>  (dd:hh:mm)  </td></tr>\n";
print "<tr $cb><td>to Cartige Set :</td><td> <input name=cartset size=3></td></tr></table>\n";

print "</form>\n";

print "<hr>\n";

&footer("scheduler.cgi", "Scheduler");

}