#!/usr/bin/perl
#
#    AFBackup Config and Mantainance Module
#    Copyright (C) 1999 by Dirk Wallmeier
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    This module inherited from the Webmin Module Template 0.79.1 by tn

require './afbackup-lib.pl';
&ReadParse();

my $srvlibdir = $config{'optionS'};
my $schvardir = "/var/log/afbackup/scheduler";

my $config_file = $srvlibdir."dwm.schedule";
my $status_file = "$schvardir/dwm.next";

my $run_schedule = "/usr/local/webmin-0.88/AFBackup/run_schedule.pl";
my $af_user = "root";

my %config;

my (@cronjobD,@cronjobW,@cronjobM);
my @jobs;
my @puh;


if ($in{'save'}) {
	&write_config;
	&redirect('scheduler.cgi');

} elsif ($in{'cron'}) {

	&write_config;
	&save_cron;
	
	&header("Daily-Weekly-Monthly Schedule", "", "");

	print "<center><font size=+1>$run_file</font></center>\n";
	print "<hr>\n";
	
	print "<p>Set Cron job for Daily:<br>\n";
	print "hh:".$in{'cronDh'}."  mm:".$in{'cronDmin'}."  days:".$in{'cronDdays'}."  Job:<i>".$in{'runDaily'}."</i></p><br>\n";
	print "<p>Set Cron job for Weekly:<br><br>\n";
	print "hh:".$in{'cronWh'}."  mm:".$in{'cronWmin'}."  days:".$in{'cronWday'}."  Job:<i>".$in{'runWeekly'}."</i></p><br>\n";
	print "<p>Set Cron job for Monthly:<br>\n";
	print "hh:".$in{'cronMh'}."  mm:".$in{'cronMmin'}."  days:".$in{'cronMday'}."  Job:<i>".$in{'runMonthly'}."</i></p><br>\n";

	print "<hr>\n";
	&footer("edit_dwm.cgi", "DWM-Schedule");

} else {

&read_cron;

&read_config;

&header("Daily-Weekly-Monthly Schedule", "", "");
print "<center><font size=+1>$run_file</font></center>\n";
print "<hr>\n";


print "<form action=edit_dwm.cgi>\n";
print "<table width=100% border=1>";

print "<tr $tb>";
print "<td>&nbsp;</td>";
print "<td>Cart-Sets Daily:</td>";
print "<td>Cart-Sets Weekly:</td>";
print "<td>Cart-Set Monthly:</td>";
print "<td>&nbsp;</td>";
print "<td>&nbsp;</td>";
print "</tr>\n";

### Daily  ####
print "<tr $tb>";
print "<td>&nbsp;</td>";
print "<td><table width=100%>";
print "<td>D1</td>";
print "<td>D2</td>";
print "<td>D3</td>";
print "<td>D4</td>";
print "<td>D5</td>";
print "</table></td>\n";
print "<td>&nbsp;</td>";
print "<td>&nbsp;</td>";
print "<td>Backup Run:</td>";
print "<td>Daily Cron Job:</td>";
print "</tr>\n";

print "<tr $cb>";
print "<td valign=top><b>Daily</b></td>\n";
print "<td valign=top><table width=100%>";
print "<tr $cb>";
print "<td><input name=D1 value=".$config{"D1"}." size=2></td>";
print "<td><input name=D2 value=".$config{"D2"}." size=2></td>";
print "<td><input name=D3 value=".$config{"D3"}." size=2></td>";
print "<td><input name=D4 value=".$config{"D4"}." size=2></td>";
print "<td><input name=D5 value=".$config{"D5"}." size=2></td>";
print "</tr></table></td>\n";
print "<td>&nbsp;</td>\n";
print "<td>&nbsp;</td>\n";
print "<td valign=top><input name=runDaily value=".$config{"runDaily"}." ></td>\n";
print "<td valign=top>";
print "<table><tr><td valign=top>";
print "Time [hh:mm] <select size=1 name=cronDh >";
for($j=0; $j<24; $j++) { printf "<option value=$j %s> $j \n", ($in{cronDh}==$j) ? "selected" : ""; }
print "</select>\n";
print ":<select size=1 name=cronDmin >";
for($j=0; $j<60; $j++) { printf "<option value=$j %s> $j \n", ($in{cronDmin}==$j) ? "selected" : ""; }
print "</select></td></tr>\n";
print "<tr><td valign=top>Days in week: <select multiple size=7 name=cronDdays>";
printf "<option value=0 %s> Sunday \n",		($in{'cronDdays'}=~/0/g) ? "selected" : "";
printf "<option value=1 %s> Monday \n", 	($in{'cronDdays'}=~/1/g) ? "selected" : "";
printf "<option value=2 %s> Tuesday \n", 	($in{'cronDdays'}=~/2/g) ? "selected" : "";
printf "<option value=3 %s> Wednesday \n", 	($in{'cronDdays'}=~/3/g) ? "selected" : "";
printf "<option value=4 %s> Thursday \n", 	($in{'cronDdays'}=~/4/g) ? "selected" : "";
printf "<option value=5 %s> Friday \n", 	($in{'cronDdays'}=~/5/g) ? "selected" : "";
printf "<option value=6 %s> Saturday \n", 	($in{'cronDdays'}=~/6/g) ? "selected" : "";
print "</select></td></tr></table>";
print "</td>\n";
print "</tr>";

##### Weekly ####
print "<tr $tb>";
print "<td>&nbsp;</td>";
print "<td>&nbsp;</td>";
print "<td><table width=100%>";
print "<tr $tb>";
print "<td>W1</td>";
print "<td>W2</td>";
print "<td>W3</td>";
print "</tr>\n";
print "</table></td>\n";
print "<td>&nbsp;</td>";
print "<td>Backup Run:</td>";
print "<td>Weekly Cron Job:</td>";
print "</tr>\n";

print "<tr $cb>";
print "<td valign=top><b>Weekly</b></td>\n";
print "<td>&nbsp;</td>\n";
print "<td valign=top><table width=100%>";
print "<tr $cb>";
print "<td><b><input name=W1 value=".$config{"W1"}." size=2></td>";
print "<td><b><input name=W2 value=".$config{"W2"}." size=2></td>";
print "<td><b><input name=W3 value=".$config{"W3"}." size=2></td>";
print "</table></td>\n";
print "<td>&nbsp;</td>\n";
print "<td valign=top><input name=runWeekly value=".$config{"runWeekly"}." ></td>\n";
print "<td valign=top><table>";
print "<tr><td colspan=3 valign=top>";
print "Time [hh:mm] <select size=1 name=cronWh >";
for($j=0; $j<24; $j++) { printf "<option value=$j %s> $j \n", ($in{cronWh}==$j) ? "selected" : ""; }
print "</select>\n";
print ":<select size=1 name=cronWmin >";
for($j=0; $j<60; $j++) { printf "<option value=$j %s> $j \n", ($in{cronWmin}==$j) ? "selected" : ""; }
print "</select></td></tr>\n";
print "<tr><td>Day of Week:<select size=1 name=cronWday>";
printf "<option value=0 %s> Sunday \n",		($in{'cronWday'}=~/0/g) ? "selected" : "";
printf "<option value=1 %s> Monday \n", 	($in{'cronWday'}=~/1/g) ? "selected" : "";
printf "<option value=2 %s> Tuesday \n", 	($in{'cronWday'}=~/2/g) ? "selected" : "";
printf "<option value=3 %s> Wednesday \n", 	($in{'cronWday'}=~/3/g) ? "selected" : "";
printf "<option value=4 %s> Thursday \n", 	($in{'cronWday'}=~/4/g) ? "selected" : "";
printf "<option value=5 %s> Friday \n", 	($in{'cronWday'}=~/5/g) ? "selected" : "";
printf "<option value=6 %s> Saturday \n", 	($in{'cronWday'}=~/6/g) ? "selected" : "";
print "</select></td></tr></table></td>\n";
print "</tr>";

### Monthly  ####
print "<tr $tb>";
print "<td>&nbsp;</td>";
print "<td>&nbsp;</td>";
print "<td>&nbsp;</td>";
print "<td><table width=100%>";
print "<tr $tb>";
print "<td>M1</td>";
print "</tr>\n";
print "</table></td>\n";
print "<td>Backup Run:</td>";
print "<td>Monthly Cron Job</td>";
print "</tr>\n";

print "<tr $cb>";
print "<td valign=top><b>Monthly</b></td>\n";

print "<td>&nbsp;</td>\n";
print "<td>&nbsp;</td>\n";
print "<td valign=top><table width=100%>";
print "<tr $cb>";
print "<td><b><input name=M1 value=".$config{"M1"}." size=2></td>";
print "</table></td>\n";
print "<td valign=top><input name=runMonthly value=".$config{"runMonthly"}." ></td>\n";
print "<td valign=top><table>";

print "<tr><td valign=top>";
print "Time [hh:mm] <select size=1 name=cronMh >";
for($j=0; $j<24; $j++) { printf "<option value=$j %s> $j \n", ($in{cronMh}==$j) ? "selected" : ""; }
print "</select>\n";
print ":<select size=1 name=cronMmin >";
for($j=0; $j<60; $j++) { printf "<option value=$j %s> $j \n", ($in{cronMmin}==$j) ? "selected" : ""; }
print "</select></td></tr>\n";
print "<tr><td valign=top>Day of month:<select size=1 name=cronMday >";
for($j=1; $j<=31; $j++) { printf "<option value=$j %s> $j \n", ($in{cronMday}==$j) ? "selected" : ""; }
print "</select></td></tr>";

print "</table></td>\n";
print "</tr>\n";
print "<tr $cb><td colspan=5>";
print "<input type=submit name=save value=\" Save Schedule\">\n";
print "<input type=reset value=\"Undo\">\n";
print "</td>";
print "<td>";
print "<input type=submit name=cron value=\" Save Cron Jobs\">\n";
print "</td></tr>\n";

print "</table>";


print "</form>\n";

print "<hr>\n";

&footer("scheduler.cgi", "Scheduler");

}

##############

sub read_config {

	open CONFIG, $config_file or die "can't open $config_file";
	foreach my $line (<CONFIG>) {
		my ($key, $value) = split("=", $line);
		$config{"$key"} = $value;
		chomp $config{"$key"};
	}
	close CONFIG;
}

sub write_config {
	open CONFIG, "> $config_file" or die "can't open $config_file for writing";
	print CONFIG "D1=".$in{ "D1" }."\n";
	print CONFIG "D2=".$in{ "D2" }."\n";
	print CONFIG "D3=".$in{ "D3" }."\n";
	print CONFIG "D4=".$in{ "D4" }."\n";
	print CONFIG "D5=".$in{ "D5" }."\n";
	print CONFIG "W1=".$in{ "W1" }."\n";
	print CONFIG "W2=".$in{ "W2" }."\n";
	print CONFIG "W3=".$in{ "W3" }."\n";
	print CONFIG "M1=".$in{ "M1" }."\n";
	print CONFIG "M2=".$in{ "M2" }."\n";
	print CONFIG "M3=".$in{ "M3" }."\n";
	print CONFIG "runDaily=".$in{ "runDaily" }."\n";
	print CONFIG "runWeekly=".$in{ "runWeekly"}."\n";
	print CONFIG "runMonthly=".$in{"runMonthly"}."\n";
	close CONFIG;
}

sub read_cron {
	&foreign_require("cron", "cron-lib.pl");
	@jobs = &foreign_call("cron", "list_cron_jobs");
	#@jobs = &list_cron_jobs();
	foreach $job (grep { $_->{'command'} =~ /.*run_schedule\.pl \-[dwm]/ } @jobs ) {
		$job->{'command'} =~ /.*run_schedule\.pl \-([dwm])/;
		$cronjob{$1} = $job;
	}
	
	if ( $cronjob{'d'}) {
		$in{'cronDh'} 	 = $cronjob{'d'}->{'hours'};	
		$in{'cronDmin'} = $cronjob{'d'}->{'mins'};
		
		if ($cronjob{'d'}->{'weekdays'} =~ /^(\d+)-(\d+)$/) {
			$in{'cronDdays'}="$1";
			for($j=$1+1; $j<=$2; $j++) { $in{'cronDdays'}=$in{'cronDdays'}.",$j"; }
		} elsif ($cronjob{'d'}->{'weekdays'} eq "*") {
			$in{'cronDdays'}="0,1,2,3,4,5,6";
		} else {
			$in{'cronDdays'}=$cronjob{'d'}->{'weekdays'};
		}
	
	}	

	if ( $cronjob{'w'}) {
		$in{'cronWh'} 	= $cronjob{'w'}->{'hours'};	
		$in{'cronWmin'} = $cronjob{'w'}->{'mins'};
		$in{'cronWday'}	= $cronjob{'w'}->{'weekdays'};
	}	

	if ( $cronjob{'m'}) {
		$in{'cronMh'} 	= $cronjob{'m'}->{'hours'};	
		$in{'cronMmin'} = $cronjob{'m'}->{'mins'};
		$in{'cronMday'}	= $cronjob{'m'}->{'days'};
	}	
}

sub save_cron {
	&foreign_require("cron", "cron-lib.pl");
	@jobs = &foreign_call("cron", "list_cron_jobs");
	#@jobs = &list_cron_jobs();
	foreach $job (grep { $_->{'command'} =~ /.*run_schedule\.pl \-[dwm]/ } @jobs ) {
		$job->{'command'} =~ /.*run_schedule\.pl \-([dwm])/;
		$cronjob{$1} = $job;
	}
	
	if ( $cronjob{'d'}) {
		
		$cronjob{'d'}->{'hours'} = $in{'cronDh'} ;	
		$cronjob{'d'}->{'mins'}  = $in{'cronDmin'};
		$cronjob{'d'}->{'weekdays'} = join(',' , $in{'cronDdays'} );

		&foreign_call("cron", "change_cron_job", $cronjob{'d'} );
	
	} else {
		$job = { 'type' => 0 };
		$job->{'active'} = 1;
		$job->{'command'} = $run_schedule." -d";
		$job->{'user'} = $af_user;
		
		#("mins", "hours", "days", "months", "weekdays") 
		$job->{'hours'} = $in{'cronDh'} ;	
		$job->{'mins'} = $in{'cronDmin'};
		@d = split(/\0/, $in{'cronDdays'}); $job->{'weekdays'} = join(',' , @d ) ;
		$job->{'days'} = "*";
		$job->{'months'} = "*";
		
		&foreign_call("cron", "create_cron_job", $job );
	}	

	if ( $cronjob{'w'}) {		
		
		$cronjob{'w'}->{'hours'} = $in{'cronWh'} ;	
		$cronjob{'w'}->{'mins'}  = $in{'cronWmin'};
		$cronjob{'w'}->{'weekdays'} = $in{'cronWday'} ;

		&foreign_call("cron", "change_cron_job", $cronjob{'w'} );
	
	}# else {
#		$job = { 'type' => 0 };
#		$job->{'active'} = 1;
#		$job->{'command'} = $run_schedule." -w";
#		$job->{'user'} = $af_user;
#		
#		$job->{'hours'} = $in{'cronWh'} ;	
#		$job->{'mins'} = $in{'cronWmin'};
#		$job->{'weekdays'} = $in{'cronWday'} );
#		$job->{'days'} = "*";
#		$job->{'months'} = "*";
#		
#		&foreign_call("cron", "create_cron_job", $job );
#	}	
#
	if ( $cronjob{'m'}) {		
		$cronjob{'m'}->{'hours'} = $in{'cronMh'} ;	
		$cronjob{'m'}->{'mins'}  = $in{'cronMmin'};
		$cronjob{'m'}->{'days'}  = $in{'cronMday'};

		&foreign_call("cron", "change_cron_job", $cronjob{'m'} );
	
	}# else {
#		$job = { 'type' => 0 };
#		$job->{'active'} = 1;
#		$job->{'command'} = $run_schedule." -w";
#		$job->{'user'} = $af_user;
#		
#		$job->{'hours'} = $in{'cronMh'} ;	
#		$job->{'mins'} = $in{'cronMmin'};
#		$job->{'days'} = $in{'cronMday'} );
#		$job->{'weekdays'} = "*";
#		$job->{'months'} = "*";
#		
#		&foreign_call("cron", "create_cron_job", $job );
#	}	
#
}