#!/usr/bin/perl
#
#    AFBackup Config and Mantainance Module
#    Copyright (C) 1999 by Dirk Wallmeier
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    This module inherited from the Webmin Module Template 0.79.1 by tn

require './afbackup-lib.pl';

%access=&get_module_acl;

## put in ACL checks here if needed


## sanity checks



&header("Scheduler", "", "", 1, 1, undef,"");
# uses the index_title entry from ./lang/en or appropriate

## Insert Output code here
print "<hr>\n";

$conf_dir = $config{'optionS'};

print "<h3>Backup Runs found in <i>$conf_dir</i> :</h3>\n";

foreach $run (&get_run_list) {
        #print "Clients found in $conf_dir: $client \n";
        push( @run_links  , "backup_run.cgi?run=$run.run" );
        push( @run_titles , "$run" );
        push( @run_icons  , "images/icon-run.gif" );

}

&icons_table(\@run_links, \@run_titles, \@run_icons);
print "<a href=backup_run.cgi?newrun=1>create a new backup run</a> &nbsp; &nbsp; &nbsp; &nbsp;";
print "<a href=backup_run.cgi?delrun=1>delete a backup run</a>";
print "<hr>\n";
print "<p>";

push( @sched_links  , "edit_dwm.cgi" );
push( @sched_titles , "DWM-Schedule" );
push( @sched_icons  , "images/icon-scheduler.gif" );
&icons_table(\@sched_links, \@sched_titles, \@sched_icons);

print "<a href=create_schedule.cgi?create=dwm>create a new DWM (daily-weekly-monthly) Schedule</a> &nbsp; &nbsp;";
print "<a href=create_schedule.cgi?create=mlm>create a new MLM (multi-level-media) Schedule</a> &nbsp; &nbsp;";
print "<a href=delete_schedule.cgi>delete a backup Schedule</a>";
print "<p>";
print "<hr>\n";

&footer("/AFBackup", "Modul Index");
# uses the index entry in /lang/en



## if subroutines are not in an extra file put them here


### END of scheduler.cgi ###.
