#!/usr/bin/perl
#
#    AFBackup Config and Mantainance Module
#    Copyright (C) 1999 by Dirk Wallmeier
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    This module inherited from the Webmin Module Template 0.79.1 by tn

require './afbackup-lib.pl';
&ReadParse();
#$conf = &get_config();
$cache_dir = $in{'dir'};
$cache_dir .= '/' if ($cache_dir !~ /\/$/);

&create_new($in{'nvol'}) if ( $in{'new'} );

#%access = &get_module_acl();
#&can_edit_zone(\%access, $conf->[$in{'index'}]->{'value'}) ||
#	&error($text{'master_ecannot'});
#$access{'file'} || &error($text{'text_ecannot'});

&header("Disk Cache", "", "Disk_Cache");
print "<hr>\n";

print "<form action=disk_cache.cgi>\n";

print "<table border width=100%>\n";

print "<tr $cb> <td><table>\n";
print "<tr $cb>\n<td width = 20%><b>Directory for Disk Cache :&nbsp;</b></td>\n";
print "<td><input name=\"dir\" value=\"$cache_dir\" size=80%></td>\n";
print "<td width=40 allign=left >&nbsp;".&file_chooser_button('dir', 1, 0)."</td>"; # dir-chooser
print "</tr>\n";
print "<tr $cb>";
print "<td><input type=submit value=\"Update\">&nbsp;<input type=reset value=\"Undo\">&nbsp;</td>";
print "<td colspan=2>";
#print "<input type=button value=\"Create New\"onClick='nvol = document.forms[0].nvol; dir = document.forms[0].dir; confirm = window.open(\"confirm.cgi?text=".&urlize("Create NVOL Volume Subdirs. This will delete all files in <i>DIR</i> ?")."&nvol=\"+nvol.value+\"&dir=\"+dir.value, \"confirm\", \"toolbar=no,menubar=no,scrollbar=no,width=500,height=100\"); confirm.nvol = nvol' >";
print "<input type=submit name=\"new\" value=\"Create New\" >";
print "&nbsp;<input name=\"nvol\" value=\"$nvol\" size=10> Volumes</td>\n";
# input type=button onClick='ifield = document.forms[0].dir; chooser = window.open("/chooser.cgi?type=1&chroot=/&file="+ifield.value, "chooser", "toolbar=no,menubar=no,scrollbar=no,width=400,height=300"); chooser.ifield = ifield' value="...">
print "</tr></table></td>";

if (-d $cache_dir ) {
print "<tr $cb> <td><table border width=100% >\n";
print "<tr $tb>\n";
print "<td colspan=3 ><b>Volumes in <tt>$cache_dir</tt></b></td>";
print "<td><b>CartNr</b></td>";
print "<td><b>2nd Nr</b></td>";
print "<td><b>Access Time</b></td>";
print "<td><b>Labeling Time</b></td>";
print "<td><b>Blocksize</b></td>";
print "<td><b>Prog.Version</b></td>";
print "<td><b>Comment</b></td>";
print "</tr>\n";

#print "<tr $cb>\n";
opendir(DIR, $cache_dir);
opendir(DIR, $cache_dir); @sorted_cache = map { $_->[0] }
                           sort { $a->[1] <=> $b->[1] }
                           map { [$_, ( /\.(\d+)/ )[0] ]} readdir(DIR); closedir(DIR);
foreach $f ( @sorted_cache ) {
	$path = "$cache_dir$f";
	if ($f eq "." || $f eq "..") { next; }
	if (!(-d $path)) { next; }
	if ( $f !~ /^vol\./ ) { next; }

        print "<tr $cb>\n";

        $icon = "dir.gif";
	print "<td><a href=disk_volume.cgi?vol=".&urlize($f)."&dir=".&urlize($cache_dir)."><img border=0 src=/images/$icon></a></td>\n";

        print "<td nowrap>$f</td>\n";

        qx(du -sb $path) =~ /([0-9]+)/;
	printf "<td nowrap>%s</td>\n",
		$1 > (1024*1024*1024) ? int($1/1024/1024)." MB" :
		$1 > (1024*1024) ? int($1/1024/1024)." MB" :
		$1 > 1024 ? int($1/10240)." kB" :
		$1;

        opendir(VOLDIR, $path); @sorted = map { $_->[0] }
                           sort { $b->[1] <=> $a->[1] }
                           map { [$_, ( /\.(\d+)/ )[0] ]} readdir(VOLDIR); closedir(VOLDIR);
        #@st = stat($sorted[0]);
        @st = stat($path."/$sorted[0]");
	@tm = localtime($st[9]);
	#printf "<td nowrap><tt>%s %.2d %.2d:%.2d:%.2d</tt></td>", $text{'smonth_'.($tm[4]+1)}, $tm[3], $tm[2], $tm[1], $tm[0];
        #print "<td>$sorted[0]</td>";

        $data0 = $path."/data.0";
        open(DATA0, $data0);
        foreach $l (<DATA0>) {
                if ($l =~ /Cartridge number:\t*(.+)[\n\r]*/)    { print "<td nowrap align=center>$1</td>\n" }
                if ($l =~ /2nd cartridge number:\t*(.+)[\n\r]*/) { print "<td nowrap align=center>$1</td>\n" }
                if ($l =~ /Labeling time:\t*[\w]{3} (.+) [\d]{4}/) {
                        printf "<td nowrap><tt>%s %.2d %.2d:%.2d:%.2d</tt></td>", $text{'smonth_'.($tm[4]+1)}, $tm[3], $tm[2], $tm[1], $tm[0];
                        print "<td nowrap ><tt>$1</tt></td>\n" }
                if ($l =~ /Tape Blocksize:\t*(.+)[\n\r]*/)      { print "<td nowrap align=right>$1</td>\n" }
                if ($l =~ /Program version:\t*(.+)[\n\r]*/)     { print "<td nowrap > $1</td>\n" }
                if ($l =~ /Comment:\t*(.+)[\n\r]*/)             { print "<td nowrap >".&html_escape($1)."</td>\n" }
        }
        close(DATA0);
        print "</tr>\n";

}
closedir(DIR);
print "</table></td>";
#print "</tr></table></td>";
}

print "</tr></table></form>\n";


print "<hr>\n";

&footer("index.cgi", "Module index");

#####
# crete new vol subdirs and lable them
#
sub create_new {
  my $count = shift;
  my $i = 0;
  my $c = 0;
  until ($c == $count) {
    $vol_cand = $cache_dir."vol.".$i;
    if (! -d $vol_cand) {
      mkdir( $vol_cand, 0777);
      $data = $vol_cand."/data";
      $data0 = $vol_cand."/data.0";
      &label_disk_vol("$data0", $i, $i, 1024);
      symlink($data0, $data);
      $c++;
    }
    $i++
  }
}

sub get_data_max {
  opendir(VOLDIR, $_1); @sorted = map { $_->[0] }
                           sort { $b->[1] <=> $a->[1] }
                           map { [$_, ( /\.(\d+)/ )[0] ]} readdir(VOLDIR); closedir(VOLDIR);
  return $sorted[0];
}

sub get_vol_max {
  opendir(BUDIR, $_1); @sorted = map { $_->[0] }
                           sort { $b->[1] <=> $a->[1] }
                           map { [$_, ( /vol\.(\d+)/ )[0] ]} readdir(BUDIR); closedir(BUDIR);
  return $sorted[0];
}



